﻿Option Explicit On
Public Class QRコード変換
    'QRコードをファイルに出力するFunction
    Private Declare Function EncQRCdToFile Lib "HiEncQRCd.dll" _
        (ByVal nLevel As Integer, ByVal nVer As Integer, ByVal bAutoExtent As Integer, _
         ByVal nMaskNo As Integer, ByVal nMag As Integer, _
         ByVal strSrcData As String, ByVal sFileName As String, _
         ByRef rnSize As Integer, ByRef rnMaskNo As Integer) As Integer

    'ライブラリのライセンスチェックFunction
    Private Declare Function QRCdChkPswd Lib "HiEncQRCd.dll" _
        (ByVal pcode As Integer, ByVal strPassWord As String) As Integer

    Dim Canvas As Bitmap 'ビットマップを描画するキャンバス

    Private Sub 変換ボタン_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles 変換ボタン.Click
        Dim sSize As Integer
        Dim maskNo As Integer
        Dim ret As Integer
        Dim xs, ys As Integer
        '変換ボタンクリックでQRコードを描く

        If 入力文字.Text.Length = 0 Then
            MsgBox("入力文字が在りません")
            Exit Sub
        End If

        'ImageオブジェクトのGraphicsオブジェクトを作成する。
        Dim grf As Graphics = Graphics.FromImage(Canvas)

        'ライセンスキーのチェック。
        ret = QRCdChkPswd(0, "test")    'ライセンスキーを入れると正規モードで動作します。
        If ret >= 0 Then
            'QRコードを画像ファイルに出力する。
            ret = EncQRCdToFile(レベル選択.SelectedIndex, バージョン選択.SelectedIndex + 1, _
                            1, -1, 倍率選択.SelectedIndex + 1, 入力文字.Text, _
                            "C:\QRCode1.bmp", sSize, maskNo)
            If ret >= 0 Then
                '画像ファイルを読み込んで、Imageオブジェクトとして取得する。
                Dim img As Image = Image.FromFile("C:\QRCode1.bmp")

                '画像をCanvasの中心の位置に描画する。
                xs = (Canvas.Width - img.Width) / 2
                ys = (Canvas.Height - img.Height) / 2
                grf.DrawImage(img, xs, ys, img.Width, img.Height)

                'Imageオブジェクトのリソースを解放する。
                img.Dispose()

                'PictureQRにQRコードを表示する。
                PictureQR.Image = Canvas
            Else
                MsgBox("QRコード変換でエラーが発生しました。エラー番号＝" + ret.ToString)
            End If
        Else
            MsgBox("ライセンスチェックでエラーが発生しました。エラー番号＝" + ret.ToString)
        End If

        'Graphicsオブジェクトのリソースを解放する
        grf.Dispose()
    End Sub

    Private Sub QRコード変換_Shown(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Shown
        Dim i As Integer

        レベル選択.Items.Add("L")
        レベル選択.Items.Add("M")
        レベル選択.Items.Add("Q")
        レベル選択.Items.Add("H")
        レベル選択.SelectedIndex = 1

        For i = 1 To 5
            倍率選択.Items.Add(i.ToString)
        Next i
        倍率選択.SelectedIndex = 0

        For i = 1 To 40
            バージョン選択.Items.Add(i.ToString)
        Next i
        バージョン選択.SelectedIndex = 0

        'Canvas(Bitmap)を生成する。
        Canvas = New Bitmap(PictureQR.Width, PictureQR.Height)
    End Sub

    Private Sub 終了ボタン_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles 終了ボタン.Click
        Canvas.Dispose()
        Me.Close()
        Me.Dispose()
    End Sub

    Private Sub コピーボタン_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles コピーボタン.Click

        '画像ファイルを読み込んで、Bitmapを生成する。
        Dim bmp As New Bitmap("C:\QRCode1.bmp")

        'クリップボードにBitmapをコピーする。
        Clipboard.SetImage(bmp)

        'Bitmapのリソースを解放する。
        bmp.Dispose()
    End Sub
End Class

